#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_RedJumpCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_RedJumpCFG> Fish_RedJumpCFG::msSingleton(nullptr);

int Fish_RedJumpCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_RedJumpCFGData* Fish_RedJumpCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_RedJumpCFGData>& Fish_RedJumpCFG::GetMapData()
{
	return mMapData;
}

void Fish_RedJumpCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_RedJumpCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_RedJumpCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRoomOrder = element->IntAttribute("RoomOrder");
		data.mRoomId = element->IntAttribute("RoomId");
		data.mTitle = element->Attribute("Title");
		data.mResources = element->Attribute("Resources");
		data.mDesc = element->Attribute("Desc");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_RedJumpCFG::Load()
{
	Load("../Config/Fish_RedJumpCFG.xml");
}

Fish_RedJumpCFG* Fish_RedJumpCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_RedJumpCFG());
	}
	return msSingleton.get();
}
